CON

  ACK = $FD
  CX = 128
  CY = 96
  SX = 256
  SY = 192 
  
VAR

  byte col,wid

OBJ

  ser  :  "FullDuplexSerial"

PUB Start(RX,TX)
  ''Must call to start the driver. 
  ser.start(RX,TX,0,56000)

PUB Clear 
  ''Clears the screen
  init  
  ser.tx("E")

PUB colorwidth(color,width)
  ''Sets the color and width of the line
  init
  repeat
    ser.tx("c")
    ser.tx(color)
    ser.tx(width)
    if GetAck == 1
      quit
  col := color
  wid := width    

PUB Plot(x,y)
  ''Plots a single dot (pixal) on the screen    
  init
  repeat
    ser.tx("P")
    ser.tx(x)
    ser.tx(y)
    if GetAck == 1
      quit

PUB Line(x,y)
  ''Draws a line to x,y. Starts at the last ploted pixal    
  init                                                    
  repeat
    ser.tx("l")
    ser.tx(x)
    ser.tx(y)
    if GetAck == 1
      quit

PUB Box(x,y,length,height)

  plot(x,y)
  line(x,y+height)
  plot(x,y)
  line(x+length,y)
  line(x+length,y+height)
  line(x,y+height)

PUB Trench(x,y,length,height)
  ''Made for a certian game
  plot(x,y)
  line(x,y+height)
  plot(x,y)
  line(x+length,y)
  line(x+length,y+height)
 ' line(x,y+height)
  
PUB Text(x,y,str) | strs
  ''Prints text in str on the screen at x,y
  init
  strs := strsize(str)                                 
  repeat
    ser.tx("T")
    ser.tx(x)
    ser.tx(y)
    ser.str(str)
    if GetAck == 1
      quit

PUB TextBox(x,y,str)

  Textmode(2,2,6,3)

PUB Textmode(x_scale,y_scale,spacing,justification)
  ''Sets the textmode as described in the Graphics object:
  '' Set text size and justification
  ''
  ''   x_scale        - x character scale, should be 1+
  ''   y_scale        - y character scale, should be 1+
  ''   spacing        - character spacing, 6 is normal
  ''   justification  - bits[1..0]: 0..3 = left, center, right, left
  ''                    bits[3..2]: 0..3 = bottom, center, top, bottom
  init                                                    
  repeat
    ser.tx("t")
    ser.tx(x_scale)
    ser.tx(y_scale)
    ser.tx(spacing)
    ser.tx(justification)
    if GetAck == 1
      quit

PUB Cursor(x,y,size)
  ''Sets the X and Y of a cross-hair cursor. The cursor is erased with the clear screen function.
  ''Size adjusts the scale of the cross hairs. 5 is normal. The width is always the same.
  colorwidth(col,1)                                             
  Plot(x-size,y)
  Line(x+size,y)
  Plot(x,y+size)
  Line(x,y-size)
  colorwidth(col,wid)

PUB Copy      
  ''Copys the display to the buffer. Your commands will not be shown on the screen until this is called    
  init
  ser.tx("C")
  ser.tx("C")        

PRI Init

  repeat
    ser.tx("#")
    if GetAck == 1
      quit 

PRI GetAck | ackbit

  ackbit := ser.rxtime(100)
  if ackbit == ACK
    return 1
  else
    return -1  